Bug 1390512 (CVE-2016-8706)

Summary: CVE-2016-8706 memcached: SASL authentication remote code execution
Product: [Other] Security Response Reporter: Andrej Nemec <anemec>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: aortega, apevec, avibelli, ayoung, carnil, chrisw, coneill, cvsbot-xmlrpc, dmoppert, gmollett, gsterlin, hguemar, jbalunas, jorton, jschluet, jshepherd, kbasil, lhh, lindner, lpeer, markmc, matthias, mlichvar, rbryant, rrajasek, sclewis, tdecacqu, tjay, tkirby, yozone
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: memcached 1.4.33 Doc Type: If docs needed, set a value
Doc Text:
An integer overflow flaw, leading to a heap-based buffer overflow, was found in memcached's parsing of SASL authentication messages. An attacker could create a specially crafted message that would cause the memcached server to crash or, potentially, execute arbitrary code.
Story Points: ---
Clone Of: Environment:
Last Closed: 2016-11-24 05:58:07 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 1390513, 1390514, 1391262, 1391263, 1392273, 1392274    
Bug Blocks: 1390516, 1393126    

Description Andrej Nemec 2016-11-01 09:43:39 UTC
An integer overflow in process_bin_sasl_auth function which is
responsible for authentication commands of Memcached binary protocol can
be abused to cause heap overflow and lead to remote code execution.

External References:

http://www.talosintelligence.com/reports/TALOS-2016-0221/

Upstream patch:

https://github.com/memcached/memcached/commit/bd578fc34b96abe0f8d99c1409814a09f51ee71c

Comment 1 Andrej Nemec 2016-11-01 09:45:11 UTC
Created memcached tracking bugs for this issue:

Affects: fedora-all [bug 1390513]
Affects: epel-5 [bug 1390514]

Comment 2 Doran Moppert 2016-11-02 06:56:11 UTC
This flaw requires memcached compiled with SASL authentication enabled, as is the case for Red Hat Enterprise Linux 7.3.

Red Hat Enterprise Linux 7.2 and 6.x memcached packages are compiled without SASL support, so they are not affected.

Comment 10 Doran Moppert 2016-11-08 22:42:01 UTC
Mitigation:

This flaw requires memcached to be running with SASL authentication enabled, which is not the default setting. If your memcached instances are running without the "-S" command-line option, they are not vulnerable.

Comment 12 errata-xmlrpc 2016-11-23 07:49:33 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2016:2819 https://rhn.redhat.com/errata/RHSA-2016-2819.html

Comment 13 Garth Mollett 2016-11-24 05:54:41 UTC
Statement:

The version of memcached as shipped with Red Hat OpenStack Platform 9 is affected by this issue however will not be updated. The latest version of memcached from Red Hat Enterprise Linux 7 can safely be allowed to supersede the earlier versions provided in the Red Hat OpenStack Platform channels.